#ifndef _DEBUGWEB_h
#define _DEBUGWEB_h
#if defined(ARDUINO) && ARDUINO >= 100
#include "arduino.h"
#else
#include "WProgram.h"
#endif
#include "ESPAsyncWebServer.h"

extern String ntpTime;

#define G(string_literal)  (String(F(string_literal)).c_str())			//Macro to allow use of Flash for strings that can be passed to functions
#define DEBUG_PRINT(x)  debugWeb.sendWeb (x)
//#define DEBUG_PRINTF(x,...)  debugWeb.sendWebF (x,__VA_ARGS__)
#define DEBUG_PRINTF(x,...)  {char buf[400]; snprintf(buf, sizeof(buf), x,__VA_ARGS__); debugWeb.sendWeb(buf);}
//#define DEBUG_PRINTFS(x,...)  {const char *buf; snprintf(buf, sizeof(buf), x,__VA_ARGS__); debugWeb.sendWeb(buf);}
#define DEBUG_PRINTLN(x)  debugWeb.sendWebln (x)
//#define DEBUG_PRINTFS (const char * format, ...)  __attribute__ ((format (printf, 2, 3))); //{debugWeb.sendWeb(format);}

#ifdef ESP8266
#define __builtin_va_start
#define __builtin_va_end
#endif

class DebugWeb//: public Stream
{
public:
	bool wifiActive = false;
	void sendWeb(const char* data);
	void sendWebln(const char* data);

	//int available(void) override;
	//int read(void) override; 
	//int peek(void) override;
	//size_t write(uint8_t c) override;
};

extern DebugWeb debugWeb;
#endif