//Class for reading analogue temperature sensors
#include "sensors.h"

// Read ntc temperature sensors
void Sensors::readTemperatureSensors()
{
	int converted;

	DEBUG_PRINTLN(G("Read sensors"));
	Wire.beginTransmission(PCF8591); // wake up PCF8591
	Wire.write(0x04); // control byte - read ADC0 then auto-increment
	Wire.endTransmission(); // end tranmission
	Wire.requestFrom(PCF8591, 5);
	TEMP_COMPRESSOR = Wire.read();
	TEMP_COMPRESSOR = Wire.read();
	TEMP_EVAPORATOR = Wire.read();
	TEMP_EXTERNAL = Wire.read();
	TEMP_EVAPMID = Wire.read();

	for (int s = 0; s < 5; s++) {
		if (s == 4) { //The adc on the ESP itself
			//Read from ESP analogue pin
			TEMP_WATER = 1024 - analogRead(A0);
			converted = convertToTemperature(TEMP_WATER, 1024.0);
			converted += ss.adcOffset;			//Add the correction for the ESP ADC 
			DEBUG_PRINTF("Raw(%d) %s: %d: %d\n", s, sensorName[s], adcSensor[s], converted);

			//if (waterTemperature[0] == 0) {
			//	for (int i = 0; i < 10; i++)
			//		waterTemperature[i] = converted;
			//}
			//waterTemperature[sample] = converted;
			//converted = 0;
			//for (int i = 0; i < 10; i++)
			//	converted += waterTemperature[i];
			//adcSensor[4] = converted / 10;
			//sample++;
			//if (sample == 10)
			//	sample = 0;
			TEMP_WATER = converted;
		}
		else
		{
			if ((adcSensor[s] > 255) || (adcSensor[s] < 0))
				adcSensor[s] = 45;
			converted = convertToTemperature(adcSensor[s], 255.0);
			DEBUG_PRINTF("Raw(%d) %s: %d: %d\n", s, sensorName[s], adcSensor[s], converted);
			adcSensor[s] = converted;
		}

	}
	//DEBUG_PRINTF(G("Target:%d\n"), ss.targetT);
}

int Sensors::readSingle(int adc)
{
	int sensorValue;

	Wire.beginTransmission(PCF8591);	// wake up PCF8591
	Wire.write(adc);					// control byte - read ADC
	Wire.endTransmission();				// end tranmission
	Wire.requestFrom(PCF8591, 2);
	sensorValue = Wire.read();
	sensorValue = Wire.read();
	return sensorValue;
}


int Sensors::in_range(unsigned int x, int lower, int upper)
{
	int p = ((x - lower) ^ ((x ^ lower) & ((x - lower) ^ x))) >> 31;
	int q = ((upper - x) ^ ((upper ^ x) & ((upper - x) ^ upper))) >> 31;
	return 1 & ~(p | q);
}


///////////////////////////
// Stuff for NTC thermistor
///////////////////////////
// 666 ohms = 100C
// convertFactor - 255 for PCF8591, 1024 for ESP8266 Analogue pin
#define RESISTANCE 10000
int Sensors::convertToTemperature(int rawADC, double convertFactor)
{
	double Temp, tmp1;

	Temp = log(RESISTANCE*((convertFactor / rawADC - 1))); //When using PCF8591
	Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp))* Temp);
	Temp = Temp - 273.15;            // Convert Kelvin to Celcius
	return (int)Temp;
}

Sensors sensors;
